library angular2.src.mock.browser_location_mock;

import "package:angular2/test_lib.dart" show proxy, SpyObject;
import "package:angular2/src/facade/lang.dart" show BaseException;
import "package:angular2/src/facade/async.dart"
    show EventEmitter, ObservableWrapper;
import "package:angular2/src/facade/collection.dart" show List, ListWrapper;
import "package:angular2/src/router/browser_location.dart" show BrowserLocation;

@proxy
class DummyBrowserLocation extends SpyObject implements BrowserLocation {
  String internalBaseHref = "/";
  String internalPath = "/";
  String internalTitle = "";
  List<String> urlChanges = ListWrapper.create();
  EventEmitter _subject = new EventEmitter();
  DummyBrowserLocation() : super() {
    /* super call moved to initializer */;
  }
  void simulatePopState(url) {
    this.internalPath = url;
    ObservableWrapper.callNext(this._subject, null);
  }
  String path() {
    return this.internalPath;
  }
  void simulateUrlPop(String pathname) {
    ObservableWrapper.callNext(this._subject, {"url": pathname});
  }
  void pushState(dynamic ctx, String title, String url) {
    this.internalTitle = title;
    this.internalPath = url;
    ListWrapper.push(this.urlChanges, url);
  }
  void forward() {
    throw new BaseException("Not implemented yet!");
  }
  void back() {
    throw new BaseException("Not implemented yet!");
  }
  void onPopState(fn) {
    ObservableWrapper.subscribe(this._subject, fn);
  }
  String getBaseHref() {
    return this.internalBaseHref;
  }
  noSuchMethod(m) {
    return super.noSuchMethod(m);
  }
}
