library angular2.test.render.dom.shadow_dom.content_tag_spec;

import "package:angular2/test_lib.dart"
    show describe, beforeEach, it, expect, ddescribe, iit, SpyObject, el, proxy;
import "package:angular2/src/dom/dom_adapter.dart" show DOM;
import "package:angular2/src/render/dom/shadow_dom/content_tag.dart"
    show Content;

var _scriptStart = '''<script start=""></script>''';
main() {
  describe("Content", () {
    var parent;
    var content;
    beforeEach(() {
      parent = el('''<div>${ _scriptStart}</div>''');
      var contentStartMarker = DOM.firstChild(parent);
      content = new Content(contentStartMarker, "");
    });
    it("should insert the nodes", () {
      content.init(null);
      content.insert([el("<a>A</a>"), el("<b>B</b>")]);
      expect(parent).toHaveText("AB");
    });
    it("should remove the nodes from the previous insertion", () {
      content.init(null);
      content.insert([el("<a>A</a>")]);
      content.insert([el("<b>B</b>")]);
      expect(parent).toHaveText("B");
    });
    it("should clear nodes on inserting an empty list", () {
      content.init(null);
      content.insert([el("<a>A</a>")]);
      content.insert([]);
      expect(parent).toHaveText("");
    });
  });
}
